//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "FindDlgs.h"
#include "global.h"
#include "fileman.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFindDlg *FindDlg;
#define MAXFINDHISTORY 32
//---------------------------------------------------------------------------
bool __fastcall GetFindTextParams(TForm *Owner, AnsiString &text2find,
   bool &who, bool &subject, bool &headers, bool &body)
{
   bool gofind = false;
   FindDlg = new TFindDlg(Owner);
   CenterDialog(FindDlg,Owner);
   FindDlg->ShowModal();
   if (FindDlg->ModalResult==mrOk && !FindDlg->EditBox->Text.IsEmpty())
   {
      text2find = FindDlg->EditBox->Text;
      who = FindDlg->WhoBox->Checked;
      subject = FindDlg->SubjectBox->Checked;
      headers = FindDlg->HeadersBox->Checked;
      body = FindDlg->BodyBox->Checked;
      gofind = true;
   }
   delete FindDlg;
   return gofind;
}
//---------------------------------------------------------------------------
__fastcall TFindDlg::TFindDlg(TComponent* Owner)
  : TForm(Owner)
{
   AnsiString val,text;
   GetAppData(EditBox->Items,FindHistory);
   int i=0; while (i<EditBox->Items->Count)
   {              // remove any empty lines
      if (EditBox->Items->Strings[i].IsEmpty()) EditBox->Items->Delete(i);
      else i++;
   }
   if (EditBox->Items->Count)
   {
      text = EditBox->Items->Strings[0];
      EditBox->Items->Delete(0);
      for (int i=0; i<4; i++)
      {
         val = GetToken(i,text,",");
         switch(i)
         {
            case 0: WhoBox->Checked = val=="1"; break;
            case 1: SubjectBox->Checked = val=="1"; break;
            case 2: HeadersBox->Checked = val=="1"; break;
            case 3: BodyBox->Checked = val=="1"; break;
         }
      }
      if (EditBox->Items->Count)
         EditBox->Text = EditBox->Items->Strings[0];
   }
}
//---------------------------------------------------------------------------
__fastcall TFindDlg::~TFindDlg()
{
}
//---------------------------------------------------------------------------
void __fastcall TFindDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   // delete from items if present
   AnsiString text = EditBox->Text;
   if (!text.IsEmpty())
   {
      int pos = EditBox->Items->IndexOf(text);
      if (pos>=0) EditBox->Items->Delete(pos);
      EditBox->Items->Insert(0,text);
      EditBox->ItemIndex = 0;
   }
   // trim for too many items
   while (EditBox->Items->Count>MAXFINDHISTORY)
      EditBox->Items->Delete(EditBox->Items->Count-1);
   // save checkbox states
   AnsiString bools="";
   bools += WhoBox->Checked ? "1,":"0,";
   bools += SubjectBox->Checked ? "1,":"0,";
   bools += HeadersBox->Checked ? "1,":"0,";
   bools += BodyBox->Checked ? "1":"0";
   EditBox->Items->Insert(0,bools);
   // save to database
   PutAppData(FindHistory,EditBox->Items);
}
//---------------------------------------------------------------------------
