//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "KeyringClrDlgs.h"
#include "fileman.h"
#include "helpdlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TKeyringClrDlg *KeyringClrDlg;
//---------------------------------------------------------------------------
bool __fastcall KeyringClearKeys(TForm *Owner, AnsiString Name, bool &clearall)
{
   KeyringClrDlg = new TKeyringClrDlg(Owner,Name);
   KeyringClrDlg->ShowModal();
   bool ok = KeyringClrDlg->ModalResult==mrOk;
   clearall = !KeyringClrDlg->DisabledBox->Checked;
   delete KeyringClrDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TKeyringClrDlg::TKeyringClrDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TKeyringClrDlg::TKeyringClrDlg(TComponent* Owner, AnsiString KeyringName)
	: TForm(Owner)
{
   keyringname = KeyringName;
   Label1->Caption = "Clear "+keyringname+" keyring?";
   DisabledBox->Checked = GetAppIni(KeyringKeepDisabled(),"1")=="1";
   CenterDialog(this,(TForm*)Owner);
   MyBeep(0);
}
//---------------------------------------------------------------------------
void __fastcall TKeyringClrDlg::DisabledBoxClick(TObject *Sender)
{
   PutAppIni(KeyringKeepDisabled(),DisabledBox->Checked?"1":"0");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TKeyringClrDlg::KeyringKeepDisabled()
{
   if (keyringname=="Cypherpunk") return CpkKeepDisabled;
   if (keyringname=="Mixmaster") return MixKeepDisabled;
   return "otherkeepdisabled";
}
//---------------------------------------------------------------------------
void __fastcall TKeyringClrDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("RemailerKeyrings","Clearing Keyrings","Clear Keyring");
}
//---------------------------------------------------------------------------